package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.generic.BranchInstruction;
import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.Instruction;
import org.apache.bcel.generic.InstructionHandle;

public final class BranchHandle extends InstructionHandle {
  private BranchInstruction bi;
  
  static org.apache.bcel.generic.BranchHandle getBranchHandle(BranchInstruction i) {
    return new org.apache.bcel.generic.BranchHandle(i);
  }
  
  private BranchHandle(BranchInstruction i) {
    super(i);
    this.bi = i;
  }
  
  public int getPosition() {
    return this.bi.getPosition();
  }
  
  public InstructionHandle getTarget() {
    return this.bi.getTarget();
  }
  
  public void setInstruction(Instruction i) {
    super.setInstruction(i);
    if (!(i instanceof BranchInstruction))
      throw new ClassGenException("Assigning " + i + " to branch handle which is not a branch instruction"); 
    this.bi = (BranchInstruction)i;
  }
  
  void setPosition(int pos) {
    this.bi.setPosition(pos);
    super.setPosition(pos);
  }
  
  public void setTarget(InstructionHandle ih) {
    this.bi.setTarget(ih);
  }
  
  protected int updatePosition(int offset, int maxOffset) {
    int x = this.bi.updatePosition(offset, maxOffset);
    super.setPosition(this.bi.getPosition());
    return x;
  }
  
  public void updateTarget(InstructionHandle oldIh, InstructionHandle newIh) {
    this.bi.updateTarget(oldIh, newIh);
  }
}
